(** * Variable Sets *)

Set Implicit Arguments.

Require Import language_syntax.
Require Import sublist.
Require Import environments.

(** Subcontext relation *)

Notation context := (list formula).
Notation sub_ctx_pre := incl.


(** Relation between context and parameter *)

Lemma In_op_sub (A:formula) (Ga:context) :
  A @ Ga ->
  sub_name (op A) (op_c Ga).
Proof.
  unfold sublist; induction Ga as [ | B]; simpl; intros; auto with datatypes.
  destruct H as [HL | HR]. 
  - subst; auto with datatypes.
  - auto with datatypes. 
Qed.

Implicit Arguments In_op_sub [A Ga].

Lemma sub_ctx_op : 
  forall (Ga De:context),
    sub_ctx_pre Ga De -> sub_name (op_c Ga) (op_c De).
Proof.
  unfold sub_ctx_pre; induction Ga as [ | A Ga]; auto; intros. 
  - inversion H0; auto. 
  - simpl in *; apply in_app_or in H0; destruct H0 as [HL | HR].
    + generalize (H A); intros. apply In_op_sub in H0; auto with datatypes.
    + apply IHGa; auto. 
Qed. 

Hint Resolve In_op_sub sub_ctx_op : datatypes.

